Index: lemon/CMakeLists.txt
===================================================================
--- lemon/CMakeLists.txt	(revision 458)
+++ lemon/CMakeLists.txt	(revision 459)
@@ -5,7 +5,4 @@
   base.cc
   color.cc
-  lp_base.cc
-  lp_skeleton.cc
-  lp_utils.cc
   random.cc)
 
Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 458)
+++ lemon/Makefile.am	(revision 459)
@@ -19,21 +19,27 @@
 	$(GLPK_CFLAGS) \
 	$(CPLEX_CFLAGS) \
-	$(SOPLEX_CXXFLAGS)
+	$(SOPLEX_CXXFLAGS) \
+	$(CLP_CXXFLAGS)
 
 lemon_libemon_la_LDFLAGS = \
 	$(GLPK_LIBS) \
 	$(CPLEX_LIBS) \
-	$(SOPLEX_LIBS)
+	$(SOPLEX_LIBS) \
+	$(CLP_LIBS)
 
 if HAVE_GLPK
-lemon_libemon_la_SOURCES += lemon/lp_glpk.cc lemon/mip_glpk.cc
+lemon_libemon_la_SOURCES += lemon/lp_glpk.cc
 endif
 
 if HAVE_CPLEX
-lemon_libemon_la_SOURCES += lemon/lp_cplex.cc lemon/mip_cplex.cc
+lemon_libemon_la_SOURCES += lemon/lp_cplex.cc
 endif
 
 if HAVE_SOPLEX
 lemon_libemon_la_SOURCES += lemon/lp_soplex.cc
+endif
+
+if HAVE_CLP
+lemon_libemon_la_SOURCES += lemon/lp_clp.cc
 endif
 
@@ -66,10 +72,10 @@
 	lemon/lp.h \
 	lemon/lp_base.h \
+	lemon/lp_clp.h \
 	lemon/lp_cplex.h \
 	lemon/lp_glpk.h \
 	lemon/lp_skeleton.h \
 	lemon/lp_soplex.h \
-	lemon/mip_cplex.h \
-	lemon/mip_glpk.h \
+	lemon/list_graph.h \
 	lemon/maps.h \
 	lemon/math.h \
@@ -95,7 +101,7 @@
 	lemon/bits/graph_adaptor_extender.h \
 	lemon/bits/graph_extender.h \
-	lemon/bits/lp_id.h \
 	lemon/bits/map_extender.h \
 	lemon/bits/path_dump.h \
+	lemon/bits/solver_bits.h \
 	lemon/bits/traits.h \
 	lemon/bits/variant.h \
Index: lemon/bits/solver_bits.h
===================================================================
--- lemon/bits/solver_bits.h	(revision 459)
+++ lemon/bits/solver_bits.h	(revision 459)
@@ -0,0 +1,191 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef LEMON_BITS_SOLVER_BITS_H
+#define LEMON_BITS_SOLVER_BITS_H
+
+namespace lemon {
+
+  namespace _solver_bits {
+
+    class VarIndex {
+    private:
+      struct ItemT {
+        int prev, next;
+        int index;
+      };
+      std::vector<ItemT> items;
+      int first_item, last_item, first_free_item;
+
+      std::vector<int> cross;
+
+    public:
+
+      VarIndex()
+        : first_item(-1), last_item(-1), first_free_item(-1) {
+      }
+
+      void clear() {
+        first_item = -1;
+        first_free_item = -1;
+        items.clear();
+        cross.clear();
+      }
+
+      int addIndex(int idx) {
+        int n;
+        if (first_free_item == -1) {
+          n = items.size();
+          items.push_back(ItemT());
+        } else {
+          n = first_free_item;
+          first_free_item = items[n].next;
+          if (first_free_item != -1) {
+            items[first_free_item].prev = -1;
+          }
+        }
+        items[n].index = idx;
+        if (static_cast<int>(cross.size()) <= idx) {
+          cross.resize(idx + 1, -1);
+        }
+        cross[idx] = n;
+
+        items[n].prev = last_item;
+        items[n].next = -1;
+        if (last_item != -1) {
+          items[last_item].next = n;
+        } else {
+          first_item = n;
+        }
+        last_item = n;
+
+        return n;
+      }
+
+      int addIndex(int idx, int n) {
+        while (n >= static_cast<int>(items.size())) {
+          items.push_back(ItemT());
+          items.back().prev = -1;
+          items.back().next = first_free_item;
+          if (first_free_item != -1) {
+            items[first_free_item].prev = items.size() - 1;
+          }
+          first_free_item = items.size() - 1;
+        }
+        if (items[n].next != -1) {
+          items[items[n].next].prev = items[n].prev;
+        }
+        if (items[n].prev != -1) {
+          items[items[n].prev].next = items[n].next;
+        } else {
+          first_free_item = items[n].next;
+        }
+
+        items[n].index = idx;
+        if (static_cast<int>(cross.size()) <= idx) {
+          cross.resize(idx + 1, -1);
+        }
+        cross[idx] = n;
+
+        items[n].prev = last_item;
+        items[n].next = -1;
+        if (last_item != -1) {
+          items[last_item].next = n;
+        } else {
+          first_item = n;
+        }
+        last_item = n;
+
+        return n;
+      }
+
+      void eraseIndex(int idx) {
+        int n = cross[idx];
+
+        if (items[n].prev != -1) {
+          items[items[n].prev].next = items[n].next;
+        } else {
+          first_item = items[n].next;
+        }
+        if (items[n].next != -1) {
+          items[items[n].next].prev = items[n].prev;
+        } else {
+          last_item = items[n].prev;
+        }
+
+        if (first_free_item != -1) {
+          items[first_free_item].prev = n;
+        }
+        items[n].next = first_free_item;
+        items[n].prev = -1;
+        first_free_item = n;
+
+        while (!cross.empty() && cross.back() == -1) {
+          cross.pop_back();
+        }
+      }
+
+      int maxIndex() const {
+        return cross.size() - 1;
+      }
+
+      void shiftIndices(int idx) {
+        for (int i = idx + 1; i < static_cast<int>(cross.size()); ++i) {
+          cross[i - 1] = cross[i];
+          if (cross[i] != -1) {
+            --items[cross[i]].index;
+          }
+        }
+        cross.back() = -1;
+        cross.pop_back();
+        while (!cross.empty() && cross.back() == -1) {
+          cross.pop_back();
+        }
+      }
+
+      void relocateIndex(int idx, int jdx) {
+        cross[idx] = cross[jdx];
+        items[cross[jdx]].index = idx;
+        cross[jdx] = -1;
+
+        while (!cross.empty() && cross.back() == -1) {
+          cross.pop_back();
+        }
+      }
+
+      int operator[](int idx) const {
+        return cross[idx];
+      }
+
+      int operator()(int fdx) const {
+        return items[fdx].index;
+      }
+
+      void firstItem(int& fdx) const {
+        fdx = first_item;
+      }
+
+      void nextItem(int& fdx) const {
+        fdx = items[fdx].next;
+      }
+
+    };
+  }
+}
+
+#endif
Index: lemon/config.h.in
===================================================================
--- lemon/config.h.in	(revision 458)
+++ lemon/config.h.in	(revision 459)
@@ -13,2 +13,5 @@
 /* Define to 1 if you have SOPLEX */
 #undef HAVE_SOPLEX
+
+/* Define to 1 if you have CLP */
+#undef HAVE_CLP
Index: lemon/lp.h
===================================================================
--- lemon/lp.h	(revision 458)
+++ lemon/lp.h	(revision 459)
@@ -25,10 +25,10 @@
 #ifdef HAVE_GLPK
 #include <lemon/lp_glpk.h>
-#include <lemon/mip_glpk.h>
 #elif HAVE_CPLEX
 #include <lemon/lp_cplex.h>
-#include <lemon/mip_cplex.h>
 #elif HAVE_SOPLEX
 #include <lemon/lp_soplex.h>
+#elif HAVE_CLP
+#include <lemon/lp_clp.h>
 #endif
 
@@ -44,6 +44,7 @@
   ///\ingroup lp_group
   ///
-  ///Currently, the possible values are \c GLPK or \c CPLEX
-#define DEFAULT_LP SOLVER
+  ///Currently, the possible values are \c LP_GLPK, \c LP_CPLEX, \c
+  ///LP_SOPLEX or \c LP_CLP
+#define LEMON_DEFAULT_LP SOLVER
   ///The default LP solver
 
@@ -51,36 +52,38 @@
   ///\ingroup lp_group
   ///
-  ///Currently, it is either \c LpGlpk or \c LpCplex
+  ///Currently, it is either \c LpGlpk, \c LpCplex, \c LpSoplex or \c LpClp
   typedef LpGlpk Lp;
-  ///The default LP solver identifier string
 
-  ///The default LP solver identifier string.
+  ///The default MIP solver identifier
+
+  ///The default MIP solver identifier.
   ///\ingroup lp_group
   ///
-  ///Currently, the possible values are "GLPK" or "CPLEX"
-  const char default_solver_name[]="SOLVER";
+  ///Currently, the possible values are \c MIP_GLPK or \c MIP_CPLEX
+#define LEMON_DEFAULT_MIP SOLVER
+  ///The default MIP solver.
 
-  ///The default ILP solver.
-
-  ///The default ILP solver.
+  ///The default MIP solver.
   ///\ingroup lp_group
   ///
-  ///Currently, it is either \c LpGlpk or \c LpCplex
+  ///Currently, it is either \c MipGlpk or \c MipCplex
   typedef MipGlpk Mip;
 #else
 #ifdef HAVE_GLPK
-#define DEFAULT_LP GLPK
+# define LEMON_DEFAULT_LP LP_GLPK
   typedef LpGlpk Lp;
+# define LEMON_DEFAULT_MIP MIP_GLPK
   typedef MipGlpk Mip;
-  const char default_solver_name[]="GLPK";
 #elif HAVE_CPLEX
-#define DEFAULT_LP CPLEX
+# define LEMON_DEFAULT_LP LP_CPLEX
   typedef LpCplex Lp;
+# define LEMON_DEFAULT_MIP MIP_CPLEX
   typedef MipCplex Mip;
-  const char default_solver_name[]="CPLEX";
 #elif HAVE_SOPLEX
-#define DEFAULT_LP SOPLEX
+# define DEFAULT_LP LP_SOPLEX
   typedef LpSoplex Lp;
-  const char default_solver_name[]="SOPLEX";
+#elif HAVE_CLP
+# define DEFAULT_LP LP_CLP
+  typedef LpClp Lp;  
 #endif
 #endif
Index: lemon/lp_base.cc
===================================================================
--- lemon/lp_base.cc	(revision 458)
+++ lemon/lp_base.cc	(revision 459)
@@ -23,13 +23,6 @@
 namespace lemon {
 
-  const LpSolverBase::Value
-  LpSolverBase::INF = std::numeric_limits<Value>::infinity();
-  const LpSolverBase::Value
-  LpSolverBase::NaN = std::numeric_limits<Value>::quiet_NaN();
-
-//   const LpSolverBase::Constr::Value
-//   LpSolverBase::Constr::INF = std::numeric_limits<Value>::infinity();
-//   const LpSolverBase::Constr::Value
-//   LpSolverBase::Constr::NaN = std::numeric_limits<Value>::quiet_NaN();
+  const LpBase::Value LpBase::INF = std::numeric_limits<Value>::infinity();
+  const LpBase::Value LpBase::NaN = std::numeric_limits<Value>::quiet_NaN();
 
 } //namespace lemon
